---
title: Responsive Design Mode
slug: Tools/Responsive_Design_Mode
tags:
  - Design
  - Dev Tools
  - Firefox
  - Guide
  - Responsive Design
  - Tools
  - Web Development
  - 'l10n:priority'
---
<div>{{ToolsSidebar}}</div>

<p><a href="/en-US/Apps/Progressive/Responsive">Responsive design</a> is the practice of designing a website so it looks and works properly on a range of different devices — particularly mobile phones and tablets as well as desktops and laptops.</p>

<p>The most obvious factor here is screen size, but there are other factors as well, including the pixel density of the display and whether it supports touch. Responsive Design Mode gives you a simple way to simulate these factors, to test how your website will look and behave on different devices.</p>

<h2 id="Toggling_Responsive_Design_Mode">Toggling Responsive Design Mode</h2>

<p>There are three ways to toggle Responsive Design Mode:</p>

<ul>
 <li>From the Firefox menu: Select <strong>Responsive Design Mode</strong> from the <strong>Web Developer </strong>submenu in the Firefox Menu (or <strong>Tools</strong> menu if you display the menu bar or are on macOS).</li>
 <li>From the Developer Tools toolbox: Press the <strong>Responsive Design Mode</strong> button in the <a href="/en-US/docs/Tools_Toolbox#Toolbar">Toolbox's toolbar</a>:<img alt="" src="https://mdn.mozillademos.org/files/16318/RDM_button.png" style="display: block; height: 664px; margin-left: auto; margin-right: auto; width: 852px;"></li>
 <li>From the keyboard: Press <kbd>Ctrl</kbd> + <kbd>Shift</kbd> + <kbd>M</kbd> (or <kbd>Cmd</kbd> + <kbd>Opt</kbd> + <kbd>M</kbd> on macOS).</li>
</ul>

<h2 id="Controlling_Responsive_Design_Mode">Controlling Responsive Design Mode</h2>

<p>With Responsive Design Mode enabled, the content area for web pages is set to the screen size for a mobile device. Initially, it's set to 320 x 480 pixels.</p>

<div class="note">
<p><strong>Note:</strong> The device you select when in Responsive Design Mode and the orientation (portrait or landscape) is saved between sessions.</p>
</div>

<p><img alt="" src="https://mdn.mozillademos.org/files/16816/responsive_ui.png" style="display: block; height: 893px; margin-left: auto; margin-right: auto; width: 960px;"></p>

<p>Information for the selected device is centered over the display. From left to right, the display includes:</p>

<ul>
 <li><em>Name of the selected device</em> - A drop-down list that includes whatever devices you have selected from the Device Settings screen.</li>
 <li><em>Screen size</em> - You can edit the width and height values to change the device size by editing a number directly or using the <kbd>Up</kbd> and <kbd>Down</kbd> keys to increase or decrease the value by 1 pixels on each keypress or hold and <kbd>Shift</kbd> to change the value by 10.
  <ul>
   <li>The mouse wheel changes the size values by 1 pixel at a time</li>
   <li>You can also change the device's screen size by grabbing the bottom-right corner of the viewport and dragging it to the size you want.</li>
  </ul>
 </li>
 <li><em>Orientation (portrait or landscape)</em> - This setting persists between sessions
  <ul>
   <li>
    <p>Screenshots are saved to Firefox's default download location.</p>
   </li>
   <li>
    <p>If you checked "Screenshot to clipboard" in the Developer Tools <a href="/en-US/docs/Tools/Settings">Settings</a> page, then the screenshot will be copied to the system clipboard.</p>
   </li>
  </ul>
 </li>
 <li><em>DPR (pixel ratio)</em> - Beginning with Firefox 68, the DPR is no longer editable; create a custom device in order to change the DPR</li>
 <li><em>Throttling</em> - A drop-down list where you can select the connection throttling to apply, for example 2G, 3G, or LTE</li>
 <li><em>Enable/Disable touch simulation</em> - Toggles whether or not Responsive Design Mode simulates touch events. While touch event simulation is enabled, mouse events are translated into <a href="/en-US/docs/Web/Guide/API/DOM/Events/Touch_events">touch events</a>; this includes (starting in Firefox 79) translating a mouse-drag event into a touch-drag event. (Note that when touch simulation is enabled, this toolbar icon is blue; when simulation is disabled, it is black.</li>
</ul>

<p>On the right end of the screen, three buttons allow you to:</p>

<ul>
 <li><em>Camera button</em> - take a screenshot</li>
 <li><em>Settings button</em> - Opens the RDM settings menu</li>
 <li><em>Close button</em> - closes RDM mode and returns to regular browsing</li>
</ul>

<p>The Settings menu includes the following commands:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16818/responsive_setting_menu.png" style="display: block; margin: 0 auto;"></p>

<ul>
 <li><em>Left-align Viewport</em> - when checked moves the RDM viewport to the left side of the browser window</li>
 <li><em>Show user agent</em> - when checked displays the user agent string</li>
 <li>The final two options define when the page is reloaded:
  <ul>
   <li><em>Reload when touch simulation is toggled:</em> when this option is enabled, the page is reloaded whenever you toggle touch support.</li>
   <li><em>Reload when user agent is changed: </em>when this option is enabled, the page isreloaded whenever the user agent is changed.</li>
  </ul>
 </li>
</ul>

<p>Reloading on these changes can be helpful because certain page behaviors would otherwise not be applied. For example, many pages check for touch support on load and only add event handlers if it is supported, or only enable certain features on certain browsers.</p>

<p>However, if you are not interested in examining such features (maybe you are just checking the overall layout at different sizes), these reloads can waste time and possibly result in the loss of productive work, so it is useful to be able to control these reloads.</p>

<p>Now when you change such settings for the first time, you are given a warning message that tells you these reloads are no longer automatic, and informed about how you can make them automatic. For example:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/15840/page-reload-warning.png" style="display: block; margin: 0 auto;"></p>

<h2 id="Developer_Toolbox_with_RDM">Developer Toolbox with RDM</h2>

<p>You can show or hide the Developer Tools toolbox independently of toggling Responsive Design Mode itself:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16320/RDMdevtools.png" style="display: block; height: 799px; margin-left: auto; margin-right: auto; width: 852px;">While Responsive Design Mode is enabled, you can continue browsing as you normally would in the resized content area.</p>

<h2 id="Device_selection">Device selection</h2>

<p>Just above the viewport there is a label "no device selected"; click this to see a list of device names. Select a device, and Responsive Design Mode sets the following properties to match the selected device:</p>

<ul>
 <li>Screen size</li>
 <li>Device pixel ratio (the ratio of device physical pixels to device-independent pixels)</li>
 <li>Touch event simulation</li>
</ul>

<p>Additionally, Firefox sets the <a href="/en-US/docs/Web/HTTP/Headers/User-Agent">User-Agent</a> HTTP request header to identify itself as the default browser on the selected device. For example, if you've selected an iPhone, then Firefox identifies itself as Safari. The <code><a href="/en-US/docs/Web/API/NavigatorID/userAgent">navigator.userAgent</a></code> property is set to the same value.</p>

<p>{{EmbedYouTube("JNAyKemudv0")}}</p>

<p>The devices listed in the drop-down are just a subset of the devices that can be selected. At the end of the drop-down, there is an item labeled <strong>Edit list</strong>. Select this to see a panel containing all the choices, which enables you to check the devices you want to see in the drop-down. The set of devices, and the values associated with each device, are taken from <span class="im"><a href="https://github.com/mozilla/simulated-devices">https://github.com/mozilla/simulated-devices.</a> You can also define a custom device, as described below.</span></p>

<h3 id="Creating_custom_devices">Creating custom devices</h3>

<p>You can create and save custom devices in Responsive Design Mode by clicking the <strong>Add Custom Device</strong> button. Each device can have its own:</p>

<ul>
 <li>Name</li>
 <li>Size</li>
 <li>DevicePixelRatio</li>
 <li>User Agent String</li>
 <li>Touch Screen</li>
</ul>

<p>Also, you can preview the properties of existing devices by hovering over the name in the device modal, where they display in a tooltip.</p>

<p>{{EmbedYouTube("SA0RlGtOCmE")}}</p>

<h2 id="Network_throttling">Network throttling</h2>

<p>If you do all your development and testing using a very fast network connection, users may experience problems with your site if they are using a slower connection. In Responsive Design Mode, you can instruct the browser to emulate, very approximately, the characteristics of various different types of networks.</p>

<p>The characteristics emulated are:</p>

<ul>
 <li>Download speed</li>
 <li>Upload speed</li>
 <li>Minimum latency</li>
</ul>

<p>The table below lists the numbers associated with each network type, but please do not rely on this feature for exact performance measurements; it's intended to give an approximate idea of the user experience in different conditions.</p>

<table class="fullwidth-table standard-table">
 <thead>
  <tr>
   <th scope="col">Selection</th>
   <th scope="col">Download speed</th>
   <th scope="col">Upload speed</th>
   <th scope="col">Minimum latency (ms)</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>GPRS</td>
   <td>50 KB/s</td>
   <td>20 KB/s</td>
   <td>500</td>
  </tr>
  <tr>
   <td>Regular 2G</td>
   <td>250 KB/s</td>
   <td>50 KB/s</td>
   <td>300</td>
  </tr>
  <tr>
   <td>Good 2G</td>
   <td>450 KB/s</td>
   <td>150 KB/s</td>
   <td>150</td>
  </tr>
  <tr>
   <td>Regular 3G</td>
   <td>750 KB/s</td>
   <td>250 KB/s</td>
   <td>100</td>
  </tr>
  <tr>
   <td>Good 3G</td>
   <td>1.5 MB/s</td>
   <td>750 KB/s</td>
   <td>40</td>
  </tr>
  <tr>
   <td>Regular 4G/LTE</td>
   <td>4 MB/s</td>
   <td>3 MB/s</td>
   <td>20</td>
  </tr>
  <tr>
   <td>DSL</td>
   <td>2 MB/s</td>
   <td>1 MB/s</td>
   <td>5</td>
  </tr>
  <tr>
   <td>Wi-Fi</td>
   <td>30 MB/s</td>
   <td>15 MB/s</td>
   <td>2</td>
  </tr>
 </tbody>
</table>

<p>To select a network, click the list box that's initially labeled "No throttling":</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16820/RDM_throttling.png" style="display: block; height: 815px; margin-left: auto; margin-right: auto; width: 500px;"></p>
